var RunForCover = {};

// some defaults
RunForCover.count = 4;
RunForCover.style = 'justimgs';
RunForCover.linkto = 'lastfm';

RunForCover.processXml = function(data) {
  // loop through tracks
  jQuery('track', data).each( function(_t) {
    if (0 == RunForCover.count) return;
    var img = new RunForCover.cdImage(this);
    img.showCd(RunForCover.style, RunForCover.linkto);
    RunForCover.count--;
  });
};

RunForCover.cdImage = function(trackXml) {
  // private variables
	var _url = new Array();
	var _artist, _track, _time, _trackurl;

  // private functions
  getHtml = function(_style, _linkto) {
    var _newImg = jQuery('<img />').attr('src', _url['medium']).attr('title', _artist + ': ' + _track + " (" + _time + ")");

    // how to link the image?
    switch(_linkto) {
      case 'lightbox':
        _newImg = jQuery('<a />').attr('href', _url['large']).attr('rel', 'lightbox').append(_newImg);
        break;
      case 'highslide':
        _newImg = jQuery('<a />').attr('href', _url['large']).click( function() { return hs.expand(this); }).append(_newImg);
        break;
      case 'lastfm':
      default:
        _newImg = jQuery('<a />').attr('href', _trackurl).append(_newImg);
        break;
    }

    // how to style the image?
    switch(_style) {
      case 'imgwithtxt':
        var _table = jQuery('<table />');
        var _tr    = jQuery('<tr />').appendTo(_table);
        // append image to new TD and append that to TR
        _newImg.appendTo(jQuery('<td />').appendTo(_tr));
        // append second TD with track info
        var _tdR   = jQuery('<td><b>' + _track + '</b><br />' + _artist +  '<br /><i>' + _time + '</i></td>').appendTo(_tr);
        return _table;
        break;
      case 'justimgs':
      default:
        return _newImg;
    }
  };

  urlFound = function() {
  	return ('' != _url['medium']);
  }

  getTimeAgo = function() {
  	// difference between then and now
  	var _diff = new Date() - new Date(_time);
  	var _s;
  	// first, minutes
  	_diff = _diff  / 60000;
  	if (_diff < 60) { _diff = parseInt(_diff); _s = (1 == _diff) ? '' : 's'; return _diff + ' minute' + _s + ' ago'; }
  	// hours
  	_diff = _diff / 60;
    if (_diff < 24) { _diff = parseInt(_diff); _s = (1 == _diff) ? '' : 's'; return _diff + ' hour' + _s + ' ago'; }
    // days
    _diff = _diff / 24;
    if (_diff < 7) { _diff = parseInt(_diff); _s = (1 == _diff) ? '' : 's'; return _diff + ' day' + _s + ' ago'; }
    // weeks
    _diff = _diff / 7;
    if (_diff < 4) { _diff = parseInt(_diff); _s = (1 == _diff) ? '' : 's'; return _diff + ' week' + _s + ' ago'; }
    // you call this *recent* tracks? ;-)
    _diff = _diff / 52;
    // some nice comma position
    _diff = parseInt(_diff * 1000) / 1000; _s = (_diff <= 1) ? '' : 's'; return _diff + ' year' + _s + ' ago';
  }

  // privileged functions
  this.showCd = function(_style, _linkto) {
    if (urlFound()) {
      // new list item for ordered list
      var _newLi = jQuery('<li />').appendTo(jQuery('ol#runforcover'));
      // and add HTML to this list item
      getHtml(_style, _linkto).appendTo(_newLi);
    }
  };

  // constructor code
  _url['small']  = jQuery('image[size="small"]', trackXml).text();
  _url['medium'] = jQuery('image[size="medium"]', trackXml).text();
  _url['large']  = jQuery('image[size="large"]', trackXml).text();

  _artist   = jQuery('artist', trackXml).text();
  _track    = jQuery('name', trackXml).text();
  _trackurl = jQuery('url', trackXml).text();
  if ('true' == jQuery(trackXml).attr('nowplaying')) {
    _time = 'listening now';
  } else {
    _time = jQuery('date', trackXml).text();
    _time = getTimeAgo();
  }
};